NAME
	GDu - graphically display disk usage (Version 1.1)

SYNOPSIS
	GDu [-quiet] [-links] [-num]
		[-window x y w h] [-fg num] [-bg num] [dir]

DESCRIPTION
	GDu is a program for displaying a  graphical  tree  of  disk
	space utilization,  similar to  the UN*X utilities  "du" and
	"xdu". The user can navigate through the tree structure. The
	window is divided up into several columns,  each of which is
	one level deeper  in  the directory hierarchy  (from left to
	right).  Boxes are drawn for each directory.   The amount of
	vertical space occupied by each box is directly proportional
	to  the amount of disk space  consumed by it  and all of its
	children.  The name of each directory and the amount of data
	are displayed provided that there is enough space within its
	box.   Any space at the "bottom" of a box not covered by its
	children to the right represents the space consumed by files
	in that directory (as opposed to space from its children).

	There  are  some  command line options  available  if GDu is
	started from the shell.

	-quit or -q	don't display filenames while scanning the
			directory tree.

	-links or -l	follow links and include them in the tree

	-num or -n	sort display numerically (largest first)
			default is to sort alphabetically

	-window x y w h  or  -w x y w h
			determines position and size  of the window.
			To use the system default for a value, enter
			something non-numeric, e.g. "NaN".

	-fg color	determines the color of the text and lines.

	-bg color	determines the color of the background.

	If the program is started from  the  Workbench  or  no  root
	directory is given,  a file requester  opens,  allowing  the
	user to choose a root directory.

MOUSE ACTIONS
	The user can move up or down the tree by clicking  the  left
	mouse on a directory box.  If the left most box is selected,
	the display will move up one level  (assuming  you  are  not
	already at the root).  If any other box is selected, it will
	be placed against the  left  edge  of  the  window  and  the
	display  will be rescaled  appropriately.   If the window is
	resized, the display will be rescaled. Clicking on the Close
	gadget will exit the program.

KEYSTROKES
	Several keystroke commands are supported.

	Cursor up     goto the previous directory on the same level.

	Cursor down	goto the next directory on the same level.

	Cursor right	goto the first subdirectory.

	Cursor left	go up one level (if not already at the root)

	BackSpace
	or / (usa-keymap, this is the key left of right shift)
			goto the root.

	Escape or q	exit the program.

EXAMPLE
	GDu -quiet -window 2 11 640 468 RAM:

CHANGES
	Version 1.1:
	- now frees all its allocated memory (bug reported by Roland
	  Vosseler).
	- options -num, -links
	- requester if no directory given
	- now possible to start from Workbench
	- Control-C aborts without displaying a truncated tree.

TO DO
	- keys for re-sorting the display
	- Tool Types for Workbench start
	- suggestions from You?

DISTRIBUTION
	This program is free software;  you can redistribute it and/
	or modify it  under  the  terms  of  the  GNU General Public
	License as published by the Free Software Foundation.

AUTHOR
	Rainer Khler <koehler@mpia-hd.mpg.de>
	Snail Mail:
	Rainer Khler, Hardtstrae 7, 69207 Sandhausen, Germany

	inspired by the UN*X utility "xdu" by Phillip C. Dykstra
